=== debian/changelog ===
casablanca (2.2.0-1) unstable; urgency=low

  * Initial release. (Closes: #722275)

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Mon, 03 Nov 2014 14:33:57 +0100
