=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
%:
	dh $@ --parallel --sourcedirectory=Release

override_dh_auto_clean:
	dh_auto_clean
	rm -rf html latex

override_dh_auto_build-indep:
	doxygen Release/public_apis_doxyfile

override_dh_install-indep:
	dh_install -plibcpprest-doc html/* usr/share/doc/libcpprest-doc/html

override_dh_install:
	dh_install -plibcpprest-dev Release/include                  usr/
	dh_install -plibcpprest-dev obj-*/Binaries/libcpprest.so     usr/lib/$(DEB_HOST_MULTIARCH)
	dh_install -plibcpprest2.2  obj-*/Binaries/libcpprest.so.2.2 usr/lib/$(DEB_HOST_MULTIARCH)
