## casablanca 2.4.0

=== debian/changelog ===
casablanca (2.4.0-2) unstable; urgency=medium

  * Make the package Multi-Arch: same

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Wed, 11 Mar 2015 20:29:04 +0100

casablanca (2.4.0-1) unstable; urgency=medium

  * New upstream release, bump SONAME to 2.4.
    - remove patch fix-ftbfs, addressed upstream.
    - refresh disable-outside-tests and disable ssl_test, requiring
      internet connection.
    - Update copyright file.

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Sat, 03 Jan 2015 13:52:06 +0100
