=== debian/control ===
--- 
+++ 
@@ -19,9 +19,11 @@
 Vcs-Git: git://anonscm.debian.org/collab-maint/casablanca.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/casablanca.git
 
-Package: libcpprest2.2
+Package: libcpprest2.4
 Provides: libcpprest
 Architecture: any
+Multi-Arch: same
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Shared library for Casablanca
  The C++ REST SDK (codename "Casablanca") is a Microsoft project for cloud-based
@@ -43,7 +45,9 @@
 Package: libcpprest-dev
 Section: libdevel
 Architecture: any
-Depends: libcpprest2.2 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Depends: libcpprest2.4 (= ${binary:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends}
 Description: Development files for Casablanca
  The C++ REST SDK (codename "Casablanca") is a Microsoft project for cloud-based
  client-server communication in native code using a modern asynchronous C++ API
