=== debian/rules ===
--- 
+++ 
@@ -19,4 +19,4 @@
 override_dh_install:
 	dh_install -plibcpprest-dev Release/include                  usr/
 	dh_install -plibcpprest-dev obj-*/Binaries/libcpprest.so     usr/lib/$(DEB_HOST_MULTIARCH)
-	dh_install -plibcpprest2.2  obj-*/Binaries/libcpprest.so.2.2 usr/lib/$(DEB_HOST_MULTIARCH)
+	dh_install -plibcpprest2.4  obj-*/Binaries/libcpprest.so.2.4 usr/lib/$(DEB_HOST_MULTIARCH)
